

 tempfile temp1 temp2
 
 use "orig/[SOURCE DATA FROM ATALAY ET AL BY SOC CODE AND YEAR]", clear

 rename soc_code soc_2010
 
********** CROSSWALK TO OCC_2010 USING CENSUS CROSSWALK ***************
* https://www.census.gov/topics/employment/industry-occupation/guidance/code-lists.html

*** First try to match in full SOC code
 merge m:1 soc_2010 using "crosswalks/SOC2010_to_occ2010", ///
		keep(1 3) keepusing(occ_2010) nogen
		
save `temp1', replace

* Sometimes soc_codes in crosswalk end in 0, which means they apply to any
* code with the same first 5 digits; sometimes they end in 000, which means
* they apply to any code with the same first 3 digits, so for cases that remain
* unmatched, we can match at these more aggregated levels.

* First try to match on first 5 digits:
use "crosswalks/SOC2010_to_occ2010", clear
drop if soc_2010_first5==.
save `temp2', replace

use `temp1', clear
tostring soc_2010, gen(str_soc_2010)
gen soc_2010_first5 = substr(str_soc_2010,1,5)
destring soc_2010_first5, replace
merge m:1 soc_2010_first5 using `temp2', ///
	keep(1 3 4 5) keepusing(occ_2010) update nogen
save `temp1', replace

* Then try to match on first 3 digits:
use "crosswalks/SOC2010_to_occ2010", clear
drop if soc_2010_first3==.
save `temp2', replace

use `temp1', clear
gen soc_2010_first3 = substr(str_soc_2010,1,3)
destring soc_2010_first3, replace
merge m:1 soc_2010_first3 using `temp2', ///
	keep(1 3 4 5) keepusing(occ_2010) update nogen


drop str_soc_2010 soc_2010_first5 soc_2010_first3


********** CROSSWALK TO DORN CODES ***************
*** Now, convert occ_2010 to Dorn codes
rename occ_2010 occ2010
merge m:1 occ2010 using "crosswalks/occ10to_00_mo_dd", ///
	keepusing(occ1990dd) nogen keep(1 3)
tab soc_2010 if occ1990dd==.


********** COLLAPSE TO ONE OBS PER DORN CODE ***************
*** Weighting sub-occs using # of ads (variable ct2)
collapse activity_* style_* skill_* requirement_* degree_* software_* ///
		deming_* spitz_* big5_* training_* length words [fw=ct2], ///
			by(occ1990dd year) fast

***** DO 3-YR AND 5-YR AVERAGE FOR DEMING AND SPITZ-OENER MEASURES *****
* Use any available years between t-4 and t
tsset occ1990dd year
tsfill, full
foreach var of varlist deming_* spitz_* {
	forvalues i=1/4 {
	gen aux`i'=L`i'.`var'
	}
	egen ma5_`var'=rowmean(`var' aux1 aux2 aux3 aux4)
	egen ma3_`var'=rowmean(`var' aux1 aux2)
	drop aux1 aux2 aux3 aux4
}
	
save "Built/atalay_data_by_occ1990dd.dta", replace


